Subject: bug#52245: Wishlist: cycle input methods

From: Eli Zaretskii <[email-masked]>
Date: Wed, 08 Dec 2021 16:29:18 +0200

> From: Robert Pluim <[email-masked]>
> Cc: [email-masked],  [email-masked],
>   [email-masked]
> Date: Wed, 08 Dec 2021 14:44:25 +0100
> 
> >>>>> On Wed, 08 Dec 2021 15:26:05 +0200, Eli Zaretskii <[email-masked]> said:
> 
>     >> From: Robert Pluim <[email-masked]>
>     >> Hmm, so how about:
>     >> 
>     >> - default-input-method is an atom
>     >> ⇒ C-\ behaves as a toggle
>     >> 
>     >> - default-input method is a list
>     >> ⇒ C-\ cycles through them and back to nil
>     >> ⇒ C-\ with a prefix arg behaves as today, prompting
>     >> for an input method. C-\ again deactivates the input method
> 
>     Eli> Sounds good, but I don't understand how you will pull out the trick in
>     Eli> the last sentence.  How will Emacs know to "just deactivate" instead
>     Eli> of cycling?
> 
> Similar to how it knows to toggle today, by storing an "I was
> activated via prefix" state in a defvar-local state variable.

Hmm... so just C-\ to activate is not enough to cause the toggle back?

> What did you think of the C-u C-u C-\ suggestion to mean "always
> deactivate"? Or do you feel itʼs unnecessary?

Given the above, some way of turning off the input method is
necessary, I think.